library model;
import 'dart:convert';

abstract class Model
{
  Model();
  Model.parse(Map<String, dynamic> data)
  {
    parseData(data);
  }

  Model.from(Model other)
  {
    parseData(other.properties);
  }

  bool isEqual(Model other)
  {
    Map<String, dynamic> data = properties;
    Map<String, dynamic> otherData = other.properties;

    return data.keys.every((key) => otherData.keys.contains(key) && data[key] == otherData[key]);
  }

  Map<String, dynamic> get properties
  {
    Map<String, dynamic> data = new Map();
    data["added_by"] = addedBy;
    data["created"] = created;
    data["status"] = status;
    return data;
  }

  String get toJSON
  {
    return JSON.encode(properties);
  }

  void parseData(Map<String, dynamic> data)
  {
    addedBy = data["added_by"];
    created = data["created"];
    status = data["status"];
  }

  String addedBy;
  String created;
  String status = "active"; // active, frozen, disabled

}